#include "APF.h"

Passage *passages = NULL;
unsigned long idcounter_passages = 0;

Passage::Passage(GridPoint p1, GridPoint p2, unsigned long cost1, unsigned long cost2, unsigned long _dir) {
	
	point1.p = p1;
	point2.p = p2;
	// when going from point 1 to point 2, the algorithm will go from point 2 to point 1
	// this means the algorithm will read the cost of point 1
	point1.cost = cost1;
	point2.cost = cost2;
	dir = _dir;
	
	Passage *np;
	for(Passage *passage = passages; passage!=NULL; passage = np) {
		np = passage->next;
		if((passage->point1.p==point1.p && passage->dir==dir) ||
		  (passage->point2.p==point2.p && passage->dir==dir) ||
		  (passage->point1.p==point2.p && passage->dir==10-dir) ||
		  (passage->point2.p==point1.p && passage->dir==10-dir)) {
			delete passage;
		}
	}
	point1.p.grid->GetCell(point1.p.x, point1.p.y).passage[dir/2-1] = &point2;
	point2.p.grid->GetCell(point2.p.x, point2.p.y).passage[(10-dir)/2-1] = &point1;
	
	prev = NULL;
	next = passages;
	if(next!=NULL) next->prev = this;
	passages = this;
	id = ++idcounter_passages;
}

Passage::~Passage() {
	
	point1.p.grid->GetCell(point1.p.x, point1.p.y).passage[dir/2-1] = NULL;
	point2.p.grid->GetCell(point2.p.x, point2.p.y).passage[(10-dir)/2-1] = NULL;
	
	if(prev!=NULL) prev->next = next;
	else passages = next;
	if(next!=NULL) next->prev = prev;
	
}

Passage* Passage::Find(unsigned long id) {
	for(Passage *passage = passages; passage!=NULL; passage = passage->next) {
		if(passage->id==id) return passage;
	}
	return NULL;
}

